#Compile Exe "pbBFVolClient"
#Include "Win32api.inc"
#Include "Main.inc"
#Include "pbVolumes.inc"


Function fnWndProc_OnLButtonDown(Wea As WndEventArgs) As Long
  Local szText As Asciiz*128
  Local oBFVol As pbBdFtVols
  Local oCFVol As pbCuFtVols
  Local hDC As Dword

  hDC=GetDC(Wea.hWnd)
  Call SetBkMode(hDC,%TRANSPARENT)
  oBFVol=NewCom "pbVolumes"
  If IsObject(oBFVol) Then
     oBFVol.Species      = 30
     oBFVol.Dbh          = 16.0
     oBFVol.SawlogHeight = 48.0
     oBFVol.Cull         = 0
     oBFVol.FormClass    = 78
     szText="oBFVol.PsuVolume()                = " & Str$(oBFVol.PsuVolume())
     TextOut(hDC,0,0,szText,Len(szText))
     szText="oBFVol.FormClassVolume()     = " & Str$(oBFVol.FormClassVolume())
     TextOut(hDC,0,18,szText,Len(szText))
     Let oCFVol=oBFVol             'this does a QueryInterface() on class and obtains another interface pointer
     If IsObject(oCFVol) Then
        oBFVol.Species      = 30
        oBFVol.Dbh          = 10.0
        oBFVol.SawlogHeight = 48.0
        oBFVol.Cull         = 0
        szText="oCFVol.PsuVolume()                 = " & Str$(oCFVol.PsuVolume())
        TextOut(hDC,0,36,szText,Len(szText))
        Set oCFVol=Nothing
     End If
     Set oBFVol=Nothing
  Else
     MsgBox("Couldn't Connect To pbBdFtVols!")
  End If
  Call ReleaseDC(Wea.hWnd,hDC)

  fnWndProc_OnLButtonDown=0
End Function


Function fnWndProc_OnClose(Wea As WndEventArgs) As Long
  Call PostQuitMessage(0)
  Call DestroyWindow(Wea.hWnd)
  fnWndProc_OnClose=0
End Function


Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Local wea As WndEventArgs
  Register iReturn As Long
  Register i As Long

  For i=0 To 1
    If wMsg=MsgHdlr(i).wMessage Then
       wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
       Call Dword MsgHdlr(i).dwFnPtr Using FnPtr(wea) To iReturn
       fnWndProc=iReturn
       Exit Function
    End If
  Next i

  fnWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Sub AttachMessageHandlers()
  ReDim MsgHdlr(1) As MessageHandler  'Associate Windows Message With Message Handlers
  MsgHdlr(0).wMessage=%WM_LBUTTONDOWN   :   MsgHdlr(0).dwFnPtr=CodePtr(fnWndProc_OnLButtonDown)
  MsgHdlr(1).wMessage=%WM_CLOSE         :   MsgHdlr(1).dwFnPtr=CodePtr(fnWndProc_OnClose)
End Sub


Function WinMain(ByVal hIns As Long,ByVal hPrev As Long,ByVal lpCL As Asciiz Ptr,ByVal iShow As Long) As Long
  Local szAppName As Asciiz*24,szTitle As Asciiz*64
  Local wc As WndClassEx
  Local hWnd As Dword
  Local Msg As tagMsg

  Call AttachMessageHandlers()                               : szAppName="pbBdFtVolClient"
  wc.lpszClassName=VarPtr(szAppName)                         : wc.lpfnWndProc=CodePtr(fnWndProc)
  wc.cbSize=SizeOf(wc)                                       : wc.style=%CS_HREDRAW Or %CS_VREDRAW
  wc.cbClsExtra=0                                            : wc.cbWndExtra=0
  wc.hInstance=hIns                                          : wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
  wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)             : wc.hbrBackground=%COLOR_BTNFACE+1
  wc.lpszMenuName=%NULL
  Call RegisterClassEx(wc)
  szTitle="Click Form To Connect To PowerBASIC COM Dll"
  hWnd=CreateWindow(szAppName,szTitle,%WS_OVERLAPPEDWINDOW,200,100,375,300,0,0,hIns,ByVal 0)
  Call ShowWindow(hWnd,iShow)
  While GetMessage(Msg,%NULL,0,0)
    TranslateMessage Msg
    DispatchMessage Msg
  Wend

  Function=msg.wParam
End Function
